// ScanController Move sketch  - ADD YOUR STEPPER COMMANDS WHERE NEEDED
// provided input should be 10 or 14 bytes 
// byte 0    = 'F' or 'M' Fullsteps or Microsteps 
// byte 1    = 'F' or 'B' Forewards or Backwards 
// byte 2345 = number of steps 0001 to 9999
// byte 6789 = speed
// OPTIONAL: only usefull with noisy connection : byte 10,11,12,13 = CRC16 checksum

#define Pin4   4      // Signal at digital pin 4 Stepper Steuerung
#define Pin5   5      // Signal at digital pin 5 Stepper Steuerung
#define Pin6   6      // Signal at digital pin 6 Stepper Steuerung
#define Pin7   7      // Signal at digital pin 7 Stepper Steuerung
#define Pin8   8      // Signal at digital pin 8 Wickelmotor Steuerung                       // Es wird nur vorwärts aufgerollt. Beim Rückwärtslauf
// zieht der Steppermotor den Film alleine von der Spule,
// da ist ein Abwickeln eher hinderlich !

void setup() {


  pinMode (Pin4, OUTPUT); // digital pin is output
  pinMode (Pin5, OUTPUT); // digital pin is output
  pinMode (Pin6, OUTPUT); // digital pin is output
  pinMode (Pin7, OUTPUT); // digital pin is output
  pinMode (Pin8, OUTPUT); // digital pin is output
  // initialize serial:
  Serial.begin(9600);
}

void loop() {
  static char buffer[80];
  uint16_t crc_out;

  int endpos = readline(Serial.read(), buffer, 80) ;   
  if ( endpos > 0) {
    //if (crcverify (buffer, endpos)){ // Uncomment for CRC check
    // Valid Command with good CRC received or no CRC checked 
    Serial.println("OK OK OK OK OK OK ");
    delay(25);
    String command(buffer);

    int nrsteps = command.substring(2,6).toInt();
    int stepdelay = command.substring(6,10).toInt();



    delay(stepdelay);
    if  (command.substring(1,2) != "B"){ // rotate forward
      digitalWrite(Pin8, HIGH);
      delay(5);
      digitalWrite(Pin8, HIGH);
    } 
    else      {
      digitalWrite(Pin8, LOW);         
      delay(5);
      digitalWrite(Pin8, LOW);                     
    }

    for (int i = 0; i < nrsteps; i++)
    {
      if(command.substring(0,1) == "F")   // perform full steps
      {
        if(command.substring(1,2) != "B") // rotate foreward
        {
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
        }
        if(command.substring(1,2) == "B") // rotate backward
        {
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
        }
      }
      if(command.substring(0,1) == "M")   // perform micro steps
      {
        if(command.substring(1,2) != "B") // rotate foreward
        {
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
        }
        if(command.substring(1,2) == "B") // rotate backward
        {
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, HIGH);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, HIGH);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, LOW);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, HIGH);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
          digitalWrite(Pin7, LOW);
          digitalWrite(Pin6, LOW);
          digitalWrite(Pin5, LOW);
          digitalWrite(Pin4, HIGH);
          delay(stepdelay);
        }
      }
    }
    digitalWrite(Pin8, LOW);
    digitalWrite(Pin7, LOW);
    digitalWrite(Pin6, LOW);
    digitalWrite(Pin5, LOW);
    digitalWrite(Pin4, LOW);
    delay(5);
    digitalWrite(Pin8, LOW);


    Serial.println("MoveEnd MoveEnd   "); 

    delay(1000);

    // }// Uncomment for CRC check
    // else{// Uncomment for CRC check
    /*
     digitalWrite(Pin8, LOW);
     digitalWrite(Pin7, LOW);
     digitalWrite(Pin6, LOW);
     digitalWrite(Pin5, LOW);
     digitalWrite(Pin4, LOW);
     delay(5);
     digitalWrite(Pin8, LOW);
     */
    //   Serial.println("ER ER"); // Uncomment for CRC check
    // }// Uncomment for CRC check
  }
}

// Helper Functions Below 

// CRC16 Function
int crcverify (char* message, unsigned long length)
{
  if (length < 5)
    return false;
  /*
   * Returns true if the last four chars in a message converted from hex to int 
   * are the crc of the preceding bytes.
   */

  unsigned short expected = crc16_ccitt(message, length - 4);
  String str(message);
  int number = (int)strtol( &str[length -4], NULL, 16);
  if (expected != number)
    Serial.println(String("FAILED CHECKSUM: Expected ") + expected + String(" received ") +  number);
  return expected == number;
}

unsigned short crc16_ccitt(char *buf, int size)
{
  unsigned short crc = 0;
  while (--size >= 0) {
    int i;
    crc ^= (unsigned short) *buf++ << 8;
    for (i = 0; i < 8; i++)
      if (crc & 0x8000)
        crc = crc << 1 ^ 0x1021;
      else
        crc <<= 1;
  }
  return crc;
}

// Readline Helper Function
int readline(int readch, char *buffer, int len)
{
  static int pos = 0;
  int rpos;

  if (readch > 0) {
    switch (readch) {
    case '\n': // Ignore new-lines
    case '\r': // Return on CR
      rpos = pos;
      pos = 0;  // Reset position index ready for next time
      return rpos;
    default:
      if (pos < len-1) {
        buffer[pos++] = readch;
        buffer[pos] = 0;
      }
    }
  }
  // No end of line has been found, so return -1.
  return -1;
}



